import pymel.core as pm
from alShaders import alShadersTemplate

class AEalCellNoiseTemplate(alShadersTemplate):
	def setup(self):
		self.addSwatch()
		self.beginScrollLayout()

		self.addControl("space", label="Space")
		self.addControl("frequency", label="Frequency")
		self.addControl("mode", label="Mode")
		self.beginLayout("Features", collapse=False)
		self.addControl("octaves", label="Octaves")
		self.addControl("lacunarity", label="Lacunarity")
		self.addControl("randomness", label="Randomness")
		self.beginLayout("Feature weights", collapse=False)
		self.addControl("f1w", label="F1")
		self.addControl("f2w", label="F2")
		self.addControl("f3w", label="F3")
		self.addControl("f4w", label="F4")
		self.addControl("mynkowskiShape", label="Shape")
		self.beginLayout("Remap", collapse=True)
		self.addControl("RMPinputMin", label="Input min")
		self.addControl("RMPinputMax", label="Input max")
		self.beginLayout("Contrast", collapse=False)
		self.addControl("RMPcontrast", label="Contrast")
		self.addControl("RMPcontrastPivot", label="Pivot")
		self.endLayout() # END Contrast
		self.beginLayout("Bias and gain", collapse=False)
		self.addControl("RMPbias", label="Bias")
		self.addControl("RMPgain", label="Gain")
		self.endLayout() # END Bias and gain
		self.addControl("RMPoutputMin", label="Output min")
		self.addControl("RMPoutputMax", label="Output max")
		self.beginLayout("Clamp", collapse=False)
		self.addControl("RMPclampEnable", label="Enable")
		self.addControl("RMPthreshold", label="Expand")
		self.addControl("RMPclampMin", label="Min")
		self.addControl("RMPclampMax", label="Max")
		self.endLayout() # END Clamp
		self.endLayout() # END Remap
		self.addControl("color1", label="Color 1")
		self.addControl("color2", label="Color 2")
		self.endLayout() # END Feature weights
		self.endLayout() # END Features
		self.beginLayout("Chips", collapse=False)
		self.addControl("smoothChips", label="Smooth chips")
		self.addControl("chipColor1", label="Chip color 1")
		self.addControl("chipProb1", label="Chip probability 1")
		self.addControl("chipColor2", label="Chip color 2")
		self.addControl("chipProb2", label="Chip probability 2")
		self.addControl("chipColor3", label="Chip color 3")
		self.addControl("chipProb3", label="Chip probability 3")
		self.addControl("chipColor4", label="Chip color 4")
		self.addControl("chipProb4", label="Chip probability 4")
		self.addControl("chipColor5", label="Chip color 5")
		self.addControl("chipProb5", label="Chip probability 5")
		self.endLayout() # END Chips
		self.addControl("P", label="P")

		pm.mel.AEdependNodeTemplate(self.nodeName)
		self.addExtraControls()

		self.endScrollLayout()
